/***************************************************************************
                                ClassLabelHistogram.h
                             ------------------
    begin                : 16.11.2005
    copyright            : (C) 2005 by Frank Moosmann and INRIA
    email                : moosmann@mrt.uka.de
 ***************************************************************************/

#ifndef CLASSLABELHISTOGRAM_H
#define CLASSLABELHISTOGRAM_H

#include "ClassLabel.h"
#include "FeatureVector.h"
#include <map>
#include <list>

class ClassLabelHistogram {

public:
  
  ClassLabelHistogram();
  ClassLabelHistogram(std::list<FeatureVector*>* sampleList);
  ~ClassLabelHistogram();
  void reset ();
  unsigned int getTotalCount();
  void getListOfClassLabels (std::list<ClassLabel>* classLabelList);
  int getCountOfLabel (ClassLabel label);
  double getWeightOfLabel (ClassLabel label);
  double getAvgWeightOfLabel (ClassLabel label);
  void increaseCountOfLabel (ClassLabel label, double weight = 1.0);
  ClassLabel getLabelWithMaxOccurance (); // should not be used!!!
  ClassLabel getRealLabelWithMaxOccurance (); // get second best label, if best class was class_0
  ClassLabel getRealLabelWithMaxWeight (); // get second best label, if best class was class_0

private:
  unsigned int memberCount;
  std::map<ClassLabel, int> countHistogram;
  std::map<ClassLabel, double> weightsumHistogram;
};
#endif //CLASSLABELHISTOGRAM_H
